Index: configure.in
===================================================================
--- configure.in	(revision 5830)
+++ configure.in	(working copy)
@@ -170,7 +170,7 @@
 # Checks for header files.
 AC_HEADER_DIRENT
 AC_HEADER_STDC
-AC_CHECK_HEADERS([sys/types.h])
+AC_CHECK_HEADERS([sys/types.h sys/resource.h sched.h])
 
 # Checks for typedefs, structures, and compiler characteristics.
 AC_C_CONST
@@ -185,7 +185,21 @@
 AC_TYPE_SIGNAL
 AC_FUNC_STRFTIME
 AC_CHECK_FUNCS([gethostname vasprintf mmap mlock mlockall usleep])
+AC_CHECK_FUNCS([sched_setscheduler setpriority setrlimit setgroups initgroups])
 
+AC_CHECK_DECL([RLIMIT_MEMLOCK],
+	[AC_DEFINE([HAVE_RLIMIT_MEMLOCK],[1],[RLIMIT_MEMLOCK constant for setrlimit])],,
+	[#ifdef HAVE_SYS_RESOURCE_H
+	 #include <sys/resource.h>
+	 #endif])
+
+AC_CHECK_DECL([SCHED_RR],
+	[AC_DEFINE([HAVE_SCHED_RR],[1],[SCHED_RR constant for sched_setscheduler])],,
+	[#ifdef HAVE_SCHED_H
+	 #include <sched.h>
+	 #endif])
+
+
 AC_C_BIGENDIAN(AC_DEFINE([SWITCH_BYTE_ORDER],__BIG_ENDIAN,[Big Endian]),AC_DEFINE([SWITCH_BYTE_ORDER],__LITTLE_ENDIAN,[Little Endian]))
 
 # Checks for integer size
Index: src/switch.c
===================================================================
--- src/switch.c	(revision 5830)
+++ src/switch.c	(working copy)
@@ -37,7 +37,12 @@
 #define _XOPEN_SOURCE 600
 #endif
 
+#ifndef _BSD_SOURCE
+#define _BSD_SOURCE 1
+#endif
+
 #include <switch.h>
+#include <switch_private.h>
 
 /* pid filename: Stores the process id of the freeswitch process */
 #define PIDFILE "freeswitch.pid"
@@ -61,7 +66,19 @@
 
 /* event to signal shutdown (for you unix people, this is like a pthread_cond) */
 static HANDLE shutdown_event;
+#else
+
+/* setuid, setgid */
+#include <unistd.h>
+
+/* getgrnam, getpwnam */
+#include <pwd.h>
+#include <grp.h>
+
+#ifdef HAVE_SYS_RESOURCE_H
+#include <sys/resource.h>
 #endif
+#endif
 
 /* signal handler for when freeswitch is running in background mode.
  * signal triggers the shutdown of freeswitch
@@ -205,6 +222,9 @@
 	const char *err = NULL;		/* error value for return from freeswitch initialization */
 #ifndef WIN32
 	int nf = 0;					/* TRUE if we are running in nofork mode */
+	uid_t runas_uid = 0;
+	gid_t runas_gid = 0;
+	struct passwd *runas_pw = NULL;
 #endif
 	int nc = 0;					/* TRUE if we are running in noconsole mode */
 	FILE *f;					/* file handle to the pid file */
@@ -214,6 +234,7 @@
 	char *usageDesc;
 	int alt_dirs = 0;
 	int known_opt;
+ 	int high_prio = 0;
 	switch_core_flag_t flags = SCF_USE_SQL;
 
 #ifdef WIN32
@@ -230,7 +251,8 @@
 		"\t-stop            -- stop freeswitch\n"
 		"\t-nc              -- do not output to a console and background\n"
 		"\t-conf [confdir]  -- specify an alternate config dir\n"
-		"\t-log [logdir]    -- specify an alternate log dir\n" "\t-db [dbdir]      -- specify an alternate db dir\n";
+		"\t-log [logdir]    -- specify an alternate log dir\n"
+		"\t-db [dbdir]      -- specify an alternate db dir\n";
 #else
 	usageDesc = "these are the optional arguments you can pass to freeswitch\n"
 		"\t-help            -- this message\n"
@@ -240,7 +262,10 @@
 		"\t-stop            -- stop freeswitch\n"
 		"\t-nc              -- do not output to a console and background\n"
 		"\t-conf [confdir]  -- specify an alternate config dir\n"
-		"\t-log [logdir]    -- specify an alternate log dir\n" "\t-db [dbdir]      -- specify an alternate db dir\n";
+		"\t-log [logdir]    -- specify an alternate log dir\n"
+		"\t-db [dbdir]      -- specify an alternate db dir\n"
+		"\t-u [user]        -- specify user to switch to\n"
+		"\t-g [group]       -- specify group to switch to\n";
 
 #endif
 
@@ -285,13 +310,41 @@
 		}
 #else
 
+		if (argv[x] && !strcmp(argv[x], "-u")) {
+			x++;
+			if (argv[x] && strlen(argv[x])) {
+				runas_pw = getpwnam( argv[x] );
+				if (!runas_pw) {
+					fprintf(stderr, "Unknown user passed to -u option\n");
+					return 255;
+				}
+				runas_uid = runas_pw->pw_uid;
+			}
+			known_opt++;
+		}
+
+		if (argv[x] && !strcmp(argv[x], "-g")) {
+			x++;
+			if (argv[x] && strlen(argv[x])) {
+				struct group *gr = NULL;
+
+				gr = getgrnam( argv[x] );
+				if (!gr) {
+					fprintf(stderr, "Unknown group passed to -g option\n");
+					return 255;
+				}
+				runas_gid = gr->gr_gid;
+			}
+			known_opt++;
+		}
+
 		if (argv[x] && !strcmp(argv[x], "-nf")) {
 			nf++;
 			known_opt++;
 		}
 #endif
 		if (argv[x] && !strcmp(argv[x], "-hp")) {
-			set_high_priority();
+			high_prio++;
 			known_opt++;
 		}
 
@@ -381,6 +434,46 @@
 #endif
 	}
 
+	if (high_prio) {
+		set_high_priority();
+	}
+
+#ifndef WIN32
+	if (runas_uid) {
+
+#ifdef HAVE_SETGROUPS
+		/*  Drop all group memberships prior to changing anything */
+		if (setgroups(0, NULL) < 0) {
+			fprintf(stderr, "Failed to drop group access list\n");
+			return 255;
+		}
+#endif
+		if (runas_gid) {
+			if (setgid(runas_gid) < 0) {
+				fprintf(stderr, "Failed to change gid!\n");
+				return 255;
+			}
+		} else {
+			if (setgid(runas_pw->pw_gid) < 0) {
+				fprintf(stderr, "Failed to change gid!\n");
+				return 255;
+			}
+
+#ifdef HAVE_INITGROUPS
+			if (initgroups(runas_pw->pw_name, runas_pw->pw_gid) < 0) {
+				fprintf(stderr, "Failed to set group access list for user\n");
+				return 255;
+			}
+#endif
+		}
+
+		if (setuid(runas_uid) < 0) {
+			fprintf(stderr, "Failed to change uid!\n");
+			return 255;
+		}
+	}
+#endif
+
 	if (switch_core_init_and_modload(nc ? lfile : NULL, flags, &err) != SWITCH_STATUS_SUCCESS) {
 		fprintf(stderr, "Cannot Initilize [%s]\n", err);
 		return 255;
Index: src/switch_core.c
===================================================================
--- src/switch_core.c	(revision 5830)
+++ src/switch_core.c	(working copy)
@@ -343,9 +343,27 @@
 }
 
 
+/*
+ * Note:
+ *   mlockall()'ed freeswitch dies on FreeBSD-6.2
+ *   (probably hitting system-wide limit)
+ */
+#if defined(HAVE_MLOCKALL) && defined(__linux__)
+#define USE_MLOCKALL
+
+#if defined(HAVE_SETRLIMIT) && defined(HAVE_RLIMIT_MEMLOCK)
+#define DISABLE_MEMLOCK_LIMIT
+#endif
+#endif
+
+
 SWITCH_DECLARE(int32_t) set_high_priority(void)
 {
-#ifdef __linux__
+#ifndef WIN32
+#ifdef DISABLE_MEMLOCK_LIMIT
+	struct rlimit lim = { RLIM_INFINITY, RLIM_INFINITY };
+#endif
+#if defined(HAVE_SCHED_SETSCHEDULER) && defined(HAVE_SCHED_RR)
 	struct sched_param sched = { 0 };
 	sched.sched_priority = 1;
 	if (sched_setscheduler(0, SCHED_RR, &sched)) {
@@ -355,20 +373,31 @@
 		}
 	}
 #endif
-
-#ifdef WIN32
-	SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);
+/*
+ * setpriority() works on FreeBSD (6.2), nice() doesn't
+ */
+#ifdef HAVE_SETPRIORITY
+	if (setpriority(PRIO_PROCESS, getpid(), -10) < 0) {
+		switch_log_printf(SWITCH_CHANNEL_LOG, SWITCH_LOG_CRIT, "Could not set nice level\n");
+	}
 #else
-	if(nice(-10)!= -10) {
+	if (nice(-10) != -10) {
 		switch_log_printf(SWITCH_CHANNEL_LOG, SWITCH_LOG_CRIT, "Could not set nice level\n");
 	}
 #endif
 
-#define USE_MLOCKALL
-#ifdef HAVE_MLOCKALL
 #ifdef USE_MLOCKALL
+#ifdef DISABLE_MEMLOCK_LIMIT
+	if (setrlimit(RLIMIT_MEMLOCK, &lim) < 0) {
+		switch_log_printf(SWITCH_CHANNEL_LOG, SWITCH_LOG_CRIT,
+			 "Failed to disable memlock limit, application may crash if run as non-root user!\n");
+	}
+#endif
 	mlockall(MCL_CURRENT | MCL_FUTURE);
 #endif
+
+#else	/* WIN32 */
+	SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);
 #endif
 	return 0;
 }